import { Toolbar } from './components/MToolbar.vue';
import { Extension } from '@codemirror/state';
import { getDefaultPlugins, getDefaultToolbarL, getDefaultToolbarR } from './utils';
import { Options } from 'remark-rehype';
import { CasketI18nData } from './lang';
import { type Plugin } from 'unified';
export interface Plugins {
    remark?: Plugin;
    rehype?: Plugin;
    remarkRehypeOptions?: Options;
    codemirror?: Extension[];
}
export type Uploader = (data: FileList) => {
    url: string;
    alt: string;
}[] | undefined;
declare let __VLS_typeProps: {
    plugins?: Plugins;
    toolbarl?: Toolbar;
    toolbarr?: Toolbar;
    i18n?: CasketI18nData[] | CasketI18nData;
    upload?: Uploader;
};
export interface CasketView {
    showEditor: boolean;
    showViewer: boolean;
    fullScreen: boolean;
    interval: number;
    data: Record<string, unknown>;
}
type __VLS_PublicProps = {
    modelValue: string;
} & typeof __VLS_typeProps;
declare const _default: import("vue").DefineComponent<__VLS_WithDefaults<__VLS_TypePropsToOption<__VLS_PublicProps>, {
    plugins: typeof getDefaultPlugins;
    toolbarl: typeof getDefaultToolbarL;
    toolbarr: typeof getDefaultToolbarR;
    i18n: () => CasketI18nData[];
    upload: () => undefined;
}>, {}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    "update:modelValue": (modelValue: string) => void;
}, string, import("vue").PublicProps, Readonly<import("vue").ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToOption<__VLS_PublicProps>, {
    plugins: typeof getDefaultPlugins;
    toolbarl: typeof getDefaultToolbarL;
    toolbarr: typeof getDefaultToolbarR;
    i18n: () => CasketI18nData[];
    upload: () => undefined;
}>>> & {
    "onUpdate:modelValue"?: ((modelValue: string) => any) | undefined;
}, {
    toolbarl: Toolbar;
    toolbarr: Toolbar;
    i18n: CasketI18nData | CasketI18nData[];
    upload: Uploader;
    plugins: Plugins;
}, {}>;
export default _default;

type __VLS_WithDefaults<P, D> = {
    [K in keyof Pick<P, keyof P>]: K extends keyof D ? __VLS_Prettify<P[K] & {
        default: D[K];
    }> : P[K];
};
type __VLS_Prettify<T> = {
    [K in keyof T]: T[K];
} & {};
type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;
type __VLS_TypePropsToOption<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: import('vue').PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: import('vue').PropType<T[K]>;
        required: true;
    };
};
